;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################


e_w_invalidEntity = 0xFF
nullptr = 0x0000

.macro DefineCmp_Entity_default
    DefineCmp_Entity 0, 0, 0, 0, e_w_invalidEntity, 1, 0x0000, e_ai_st_noAI, 0, e_cmp_null, 0 ;;, _anim_ptr
.endm

.macro DefineCmpArray_Entity _N
    .rept _N
        DefineCmp_Entity_default
    .endm
.endm

.macro DefineCmp_Entity _x, _y, _vx, _vy, _w, _h, _pspr, _aist, _hp, _cmp_type, _colide_st ;;, _anim_ptr
    .db _x,  _y
    .db _vx, _vy
    .db _w,  _h
    .dw _pspr
    .db 0x00, 0x00
    .db _aist
    .db _aist
    .dw 0x0000
    .dw 0xCCCC          ;; Last video memory screenpointer
    .dw 0x0000          ;; Last video memory buffer pointer
    .db _hp
    .db _cmp_type
    .db _x+_w-1, _y+_h-1      ;; las fisicas deben ir antes que las colisiones
    .db _colide_st
;    .dw _anim_ptr
;;; animation pointer not used, must be set to nullptr
;;; ojo hay que añadir el parametro en las macros,
;;; esta y la default, ademas de modificar las declaraciones en level
;    .db 0x00
.endm

;; ==== ENTITY DATA ====
e_x                 = 0
e_y                 = 1

e_vx                = 2
e_vy                = 3

e_w                 = 4
e_h                 = 5

e_pspr_l            = 6
e_pspr_h            = 7

e_ai_aim_x          = 8     ;; proyectil almacena el alcance restante
e_ai_aim_y          = 9

e_ai_st             = 10    ;; los proyectiles no tienen IA
e_ai_pre_st         = 11    ;; almacenamos origen x, y en estas 

e_ai_patrol_step_l  = 12
e_ai_patrol_step_h  = 13

e_lastVPS_l         = 14
e_lastVPS_h         = 15

e_lastVPB_l         = 16
e_lastVPB_h         = 17

e_hp                = 18
e_cmp_type          = 19

e_endx              = 20
e_endy              = 21

e_colide_st         = 22

;;e_anim_ptr_l      = 
;;e_anim_ptr_h      = 
;;e_anim_st         = 

sizeof_e            = 23

;; ==== IA ====
e_ai_st_noAI        = 0
e_ai_st_stand_by    = 1
e_ai_st_move_to     = 2
e_ai_st_patrol      = 3
e_ai_st_seek        = 4

;;e_cmp_Animation
;; ==== MAN/SYS ====
e_cmp_null          = 0x00
e_cmp_AI            = 0x01
e_cmp_Render        = 0x02
e_cmp_Physics       = 0x04
e_cmp_Collision     = 0x08
e_cmp_Patrol        = 0x10
e_cmp_Proyectil     = 0x20

;; La puerta solo tiene colision
e_cmp_wall          = e_cmp_Render  | e_cmp_Collision
e_cmp_jugador       = e_cmp_wall    | e_cmp_Physics
e_cmp_ai            = e_cmp_jugador | e_cmp_AI
e_cmp_ai_patrol     = e_cmp_ai      | e_cmp_Patrol
e_cmp_bullet        = e_cmp_jugador | e_cmp_Proyectil

;; ==== COLLISION ====
e_colide_st_player       = 0
e_colide_st_alien        = 1
e_colide_st_ia           = 2
e_colide_st_bullet       = 3
e_colide_st_wall         = 4
e_colide_st_door         = 5

;; TODO comprobar los indices
;e_cmpID_AI = 0
;e_cmpID_Render = 1
;e_cmpID_Physics = 2
;e_cmpID_Patrol = 3
;e_cmpID_Proyectile = 4
;e_cmpID_Animation = 5
;e_cmpID_Num_Components = 6

;e_anim_st_standing = 
;e_anim_st_walking = 
