;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################


;;
;; ANIMATIONS MANAGER
;;
.include "assets/assets.h.s"
.include "cmp/entity.h.s"
.include "cpctelera.h.s"

.module animations_manager

_warrior_standing::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_standing
_warrior_walking_left::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_left
_warrior_walking_right::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_right
_warrior_walking_down::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_down
_warrior_walking_downleft::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_downleft
_warrior_walking_downright::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_downright
_warrior_walking_up::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_up
_warrior_walking_upleft::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_upleft
_warrior_walking_upright::
;    .dw _sp_warrior_00
    .dw nullptr
    .dw _warrior_walking_upright

;; UDRL
_animations_array:
;; 0000 standing
;; 0001 left
;; 0010 right
;; 0011 -
    .dw _warrior_standing
    .dw _warrior_walking_left
    .dw _warrior_walking_right
    .dw nullptr
;; 0100 down
;; 0101 down-left
;; 0110 down-right
;; 0111 -
    .dw _warrior_walking_down
    .dw _warrior_walking_downleft
    .dw _warrior_walking_downright
    .dw nullptr
;; 1000 up
;; 1001 up-left
;; 1010 up-right
;; 1011 -
    .dw _warrior_walking_up
    .dw _warrior_walking_upleft
    .dw _warrior_walking_upright
    .dw nullptr
;; 1100 -
;; 1101 -
;; 1110 -
;; 1111 -
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw nullptr
;;========
;; Hay que expandir a +4 bits para distinguir de player o enemigo para cambiar el sprite
;; Por ejemplo 10000 Standing Ghost
;;========
;; Ademas habria que incluir a cada puntero a animacion
;; un contador para decirle al render cuanto tiempo tiene que durar dicha animacion
;;========

animation_man_getAnimHL::
;; en B viene el status de la comprobacion
    ld hl, #_animations_array
    ld a, b
;; multiplicamos por 2 para calcular la posicion dentro del array de punteros
    add a
;; sumamos a con acarreo a hl para acceder
    add_hl_a
;; ====================
;; tres formas distintas de hacer lo mismo que la macro anterior
;; ====================
;; esta primera forma es exactamente lo que hace la macro
;;    add l
;;    ld l, a
;;    jr nc, _nocarry
;;    inc h
;;_nocarry:
;;    adc h
;;    sub l
;;    ld h, a
;; ====================
;;    add l
;;    ld l, a
;;    ld a, h
;;    adc #0
;;    ld h, a
;; ====================
;;   ld e, a
;;   ld d, #0
;;   add hl, de
;; ====================
    ld a, (hl)
    inc hl
    ld h, (hl)
    ld l, a

    ret