;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################


;;
;;  MENU SYSTEMS MANAGER
;;

.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "sys/render.h.s"
.include "menu.h.s"

.module menu_manager
 
;; INIT Menu Manager
win_menu_man::
;;    ld  hl, #gamo_win_menu_array_erase
;;    call set_array_to_remove
;;    
;;    ld ix, #win_menu_array
;;    call render_sys_draw_menu

    ld  hl, #_win_menu_z_end
    ld  de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm
    ld  hl, #_win_menu_z_end
    ld  de, #0xBFFF
    call cpct_zx7b_decrunch_s_asm
    jr wait_keys

gamo_menu_man::
;;    ld  hl, #gamo_win_menu_array_erase
;;    call set_array_to_remove
;;
;;    ld ix, #gamo_menu_array
;;    call render_sys_draw_menu


    ld  hl, #_game_over_menu_z_end
    ld  de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm
    ld  hl, #_game_over_menu_z_end
    ld  de, #0xBFFF
    call cpct_zx7b_decrunch_s_asm
    jr wait_keys
;; draw_menu::
;;  
;;
start_menu_man::
;;    ld  hl, #start_menu_array_erase
;;    call set_array_to_remove
;;
;;    ld ix, #start_menu_array
;;    call render_sys_draw_menu
    ld  hl, #_instructions_menu_z_end
    ld  de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm
    ld  hl, #_instructions_menu_z_end
    ld  de, #0xBFFF
    call cpct_zx7b_decrunch_s_asm
    jr wait_keys
wait_keys:

    ;; Se generan halts para que no se salte la pantalla de inicio cuando
    ;; se pulsa enter en la pantalla de game over o en la de victoria
    cpctm_produceHalts 30

strtm_update:
    ;; Si se pulsa esc volvemos al menu de start
    ld  hl, #Key_Esc
    call cpct_isKeyPressed_asm

    jr   z, not_esc
    
;;    call render_sys_remove_menu
    jr  start_menu_man

not_esc:

    ;; Si se pulsa enter salimos del manejador de menu
    ld  hl, #Key_Return
    call cpct_isKeyPressed_asm

    jr   z, strtm_update

;;    call render_sys_remove_menu
    ret