;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################


;;
;;  PATROL MANAGER
;;
.include "cpctelera.h.s"
.include "cmp/array.h.s"
.include "man/entity.h.s"

.module patrol_manager

DefineComponentPointerArrayStructure_Size _patrol, max_entities

patrol_man_init::
    ld hl, #_patrol_ptr_array
    ld (_patrol_ptr_pend), hl

    xor a
    ld (hl), a
    ld d, h
    ld e, l
    inc de
    ld bc, #2*max_entities-1

    ldir

patrol_man_getArrayHL::
    ld hl, #_patrol_ptr_array
    ret

patrol_man_add::
    ld hl, (_patrol_ptr_pend)
    ld__a_ixl
    ld (hl), a
    inc hl
    ld__a_ixh
    ld (hl), a
    
    inc hl
    ld (_patrol_ptr_pend), hl

    ret
