;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################

;;
;;  RENDER MANAGER
;;

.include "cpctelera.h.s"
.include "cmp/array.h.s"
.include "man/entity.h.s"

.module entity_render_manager


DefineComponentPointerArrayStructure_Size _render, max_entities


;;  INPUT:
;;      -
;;  DESTROY:
;;      HL, DE, BC, A
entity_render_man_init::
    ld hl, #_render_ptr_array
    ld (_render_ptr_pend), hl

    xor a
    ld (hl), a
    ld d, h
    ld e, l
    inc de
    ld bc, #2*max_entities-1

    ldir

;;  INPUT:
;;      -
;;  OUTPUT:
;;      HL: Pointer to the render pointer array
entity_render_man_getArrayHL::
    ld hl, #_render_ptr_array
    ret


;;  INPUT:
;;      IX: Pointer to the entity
;;  DESTROY:
;;      HL, A
entity_render_man_add::
    ld hl, (_render_ptr_pend)
    ld__a_ixl
    ld (hl), a
    inc hl
    ld__a_ixh
    ld (hl), a
    
    inc hl
    ld (_render_ptr_pend), hl

    ret

entity_render_man_delete::
; DE ptr to delete

;; HL iter
    ld hl, #_render_ptr_array
    ld bc, #max_entities-1
_loop:
    push bc
;; BC ptr to check
    ld c, (hl)
    inc hl
    ld b, (hl)
    inc hl
;; if null END
    ld a, b
    or c
    ret z
;; BC == DE
    ld a, b
    cp d
    jr nz, _not_equal

    ld a, c
    cp e
    jr nz, _not_equal

_equal:
    ld d, h
    ld e, l
    
    dec de
    dec de

    pop bc

    push hl
    push de
    
    dec bc
    ld h, b
    ld l, c
    add hl, bc
    ld b, h
    ld c, l

    pop de
    pop hl

    ldir

    ld hl, (_render_ptr_pend)
    dec hl
    dec hl
    ld (_render_ptr_pend), hl

    ret

_not_equal:
    pop bc
    dec bc
    jr _loop
