;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################



;;
;;  ANIMATION SYSTEM
;;
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "man/components.h.s"
.include "man/animations.h.s"

.module animation_system

;;
;; INICIALIZACION
;;
animation_sys_init::
;;    ld a, #e_cmpID_Animation
    call components_man_getArrayHL
    ld (_ent_array_ptr), hl
    ret

;;
;; ACTUALIZAR
;;
animation_sys_update::

_ent_array_ptr = .+1
    ld hl, #0x0000

_loop:
    ld e, (hl)
    inc hl
    ld d, (hl)
    inc hl

    ld a, e
    or d
    ret z

    ld__ixl_e
    ld__ixh_d

    call calculateAnimStatus
;    ld a, e_anim_st(ix)
    cp b
    jr z, _continueAnim
_newAnimStatus:
;    ld e_anim_st(ix), b
    ex de, hl
    call animation_man_getAnimHL
;; ==== SE PODRIA OPTIMIZAR
;    ld e_anim_ptr_l(ix), l
;    ld e_anim_ptr_h(ix), h
    ex de, hl
_continueAnim:
;    ld e, e_anim_ptr_l(ix)
;    ld d, e_anim_ptr_h(ix)
    ex de, hl
;; ==== SE PODRIA OPTIMIZAR
_return2Anim:
    ld c, (hl)
    inc hl
    ld b, (hl)
    inc hl
    ld a, c
    or b
    jr z, _resetAnim
;    ld e_anim_ptr_l(ix), l
;    ld e_anim_ptr_h(ix), h
    ld e_pspr_l(ix), c ;; parte baja #<_sp_warrior_30
    ld e_pspr_h(ix), b ;; parte alta #>_sp_warrior_30
    ex de, hl
    jr _loop

_resetAnim:
    ld a, (hl)
    inc hl
    ld h, (hl)
    ld l, a
    jr _return2Anim

calculateAnimStatus:
;; check status inicial
    ld b, #0
;; Ver UDRL en "man/animations.s"
    ld a, e_cmp_type(ix)
    and #e_cmp_AI
    jr z, _is_player
_is_IA:
    ld b, #0x10
_is_player:
    ld a, e_vx(ix)
    or a
    jr z, _vx_zero
_vx_no_zero:
    jp m, _vx_neg
_vx_pos:
;; las instrucciones: bit comprueba, res resetea y set pone el bit a 1
    set 1, b
    jr _vx_zero
_vx_neg:
    set 0, b
_vx_zero:
;;
    ld a, e_vy(ix)
    or a
    jr z, _vy_zero
_vy_no_zero:
    jp m, _vy_neg
_vy_pos:
;; las instrucciones: bit comprueba, res resetea y set pone el bit a 1
    set 2, b
    jr _vy_zero
_vy_neg:
    set 3, b
_vy_zero:

    ret

