;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################



.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "man/entity_ai.h.s"
.include "cpctelera.h.s"
.include "man/collision.h.s"
.include "sys/game_status.h.s"
.include "man/menu.h.s"
.include "man/level.h.s"
.include "man/game.h.s"
.include "sys/projectile.h.s"
;;.include man/patrol.h.s
;;.include sys/collision.h.s
;;.include man/components.h.s

.module collision_system

collision_sys_init::
;;  ld a, #e_cmpID_Physics
;;  call components_man_getArrayHL
    call collision_man_getArrayHL
    ld (_ent_array_ptr), hl
    ret

.macro saveSetBorder _color
    push hl
    cpctm_setBorder_asm _color
    pop hl
.endm

;;collision_sys_update_sort::
;;    ld a, #e_cmpID_Physics
;;    call components_man_sort
;;    ld  hl, (_ent_array_ptr)

collision_sys_update::
    _ent_array_ptr = .+1
    ld  hl, #0x0000

;;    saveSetBorder HW_GREEN
_next_ix:
    ld  e,  (hl)
    inc hl 
    ld  d,  (hl)
    inc hl

    ld a, e 
    or d 
    jr z, _exit

    push hl

    ld__ixl_e
    ld__ixh_d

_next_iy:
    ld  e,  (hl)
    inc hl 
    ld  d,  (hl)
    inc hl 

    ld a, e 
    or d 
    jr z, _pop

    push hl

    ld__iyl_e
    ld__iyh_d

    call collision_sys_check
    jr c, _no_collision

_collision:
;;    saveSetBorder HW_RED    
    call collision_sys_decision
    pop hl
    jr _next_iy
    
_no_collision:
;;    saveSetBorder HW_GREEN
    pop hl
    jr _next_iy

_pop:
    pop hl
    jr _next_ix

_exit:
;;    saveSetBorder HW_WHITE
    ret
;; IX ENT1 Y IY ENT2
collision_sys_check::
    ld a, e_endx(ix)
    sub e_x(iy)
    ret c

    ld a, e_endx(iy)
    sub e_x(ix)
    ret c

    ld a, e_endy(ix)
    sub e_y(iy)
    ret c
    
    ld a, e_endy(iy)
    sub e_y(ix)
    ret

collision_sys_decision::
;; ¿¿ IX ??
;;    ld a, e_colide_st(ix)
;;    cp #e_colide_st_alien
;;    ret z
;;    ld a, e_colide_st(iy)
;;    cp #e_colide_st_alien
;;    ret z
;; ¿¿ PROYECTIL ??
    ld a, e_colide_st(ix)
    cp #e_colide_st_bullet
    jr z, _collision_sys_Xproyectil
;; PARA CUALQUIER OTRA COSA
    ld a, e_vx(ix)
    cp #0
    jr z, _xx_not_boing
    neg
    add e_x(ix)
    ld e_x(ix), a
    ld e_vx(ix), #0
_xx_not_boing:
    ld a, e_vy(ix)
    cp #0
    jr z, _xy_not_boing
    neg
    add e_y(ix)
    ld e_y(ix), a
    ld e_vy(ix), #0
_xy_not_boing:
;; ¿¿ PLAYER ??
    ld  a, e_colide_st(ix)
    cp #e_colide_st_player
    jr z, _collision_sys_Xplayer
;; SI NO ES NINGUN CASO PASAMOS
    jr _collision_sys_Xother
;; IX ES UN PROYECTIL
_collision_sys_Xproyectil:
    call projectile_sys_reset_bullet
    jr _fin
;; IX ES UN PLAYER
_collision_sys_Xplayer:
;; ¿¿ IY ??
;; ¿¿ PROYECTIL ??
    ld a, e_colide_st(iy)
    cp #e_colide_st_bullet
    jr z, _bulls_eye
;; PARA CUALQUIER OTRA COSA
    call check_y
;; ¿¿ IA ??
    ld a, e_colide_st(iy)
    cp #e_colide_st_ia
    jr z, _make_lose_health
;; ¿¿ PUERTA ??
    ld a, e_colide_st(iy)
    cp #e_colide_st_door
    jr z, _stage_clear
;; SI NO ES NINGUN CASO FIN
    jr _fin
;; PROYECTIL
_bulls_eye:
    call projectile_sys_reset_bulletY
;; IA
_make_lose_health:
    call reduce_hp
    jr _fin
;; PUERTA
_stage_clear:
    call go_to_next_level
    jr _fin
;; IX NO ES PLAYER NI BALA
_collision_sys_Xother:
;; ¿¿ IY ??
;; ¿¿ PROYECTIL ??
    ld  a, e_colide_st(iy)
    cp #e_colide_st_bullet
    jr z, _bulls_Yeye
;; PARA CUALQUIER OTRA COSA
check_y:
    ld a, e_vx(iy)
    cp #0
    jr z, _yx_not_boing
    neg
    add e_x(iy)
    ld e_x(iy), a
    ld e_vx(iy), #0
_yx_not_boing:
    ld a, e_vy(iy)
    cp #0
    jr z, _yy_not_boing
    neg
    add e_y(iy)
    ld e_y(iy), a
    ld e_vy(iy), #0
_yy_not_boing:
    ret
;; PROYECTIL
_bulls_Yeye:
    call projectile_sys_reset_bulletY
_fin:
    ret

