;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################

.include "cpctelera.h.s"
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "sys/projectile.h.s"
.include "man/physics.h.s"

.module physics_system

screen_width = 80
screen_heigth = 200

physics_sys_init::
    call physics_man_getArrayHL
    ld (_ent_array_ptr), hl
    ret

physics_sys_update::
_ent_array_ptr = .+1
    ld  hl, #0x0000

_update_loop:
    ld   e, (hl)
    inc hl
    ld   d, (hl)
    inc hl

    ld   a, e
    or   d
    ret z

    ld__ixl_e
    ld__ixh_d

    push hl
;; Maximo ancho en C
    ld a, #screen_width + 1
    sub e_w(ix)
    ld c, a
;; Siguiente coord X en A
    ld a, e_x(ix)
    add e_vx(ix)
    cp c
    jr nc, invalid_x
;; Coord X valida
valid_x:
    ld e_x(ix), a
    add e_w(ix)
    dec a
    ld e_endx(ix), a
    jr endif_x
;; Rebote
invalid_x:
    ld a, e_vx(ix)
    neg
    ld e_vx(ix), a
;; 
endif_x:
;; Maxima altura en C
    ld a, #screen_heigth - 1
    sub e_h(ix)
    ld c, a
;; Siguiente coord Y en A
    ld a, e_y(ix)
    add e_vy(ix)
    cp c
    jr nc, invalid_y
;; Coord Y valida
valid_y:
    ld e_y(ix), a
    add e_h(ix)
    dec a
    ld e_endy(ix), a
    jr endif_y
;; Rebote
invalid_y:
    ld a, e_vy(ix)
    neg
    ld e_vy(ix), a
;;
endif_y:

    pop hl

    jr _update_loop
    